/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * Copyright 2008 by Sun Microsystems, Inc.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * $RCSfile:  $
 * $Revision:  $
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
#ifndef _PARACHANGETRACKINGINFO_HXX_
#define _PARACHANGETRACKINGINFO_HXX_

#include <sal/types.h>

class SwTxtFrm;
class SwWrongList;

class SwParaChangeTrackingInfo
{
    public:
        explicit SwParaChangeTrackingInfo( const SwTxtFrm& rTxtFrm );
        ~SwParaChangeTrackingInfo();

        void reset();

        const SwWrongList* getChangeTrackingTextMarkupList( const sal_Int32 nTextMarkupType );

    private:
        SwParaChangeTrackingInfo( const SwParaChangeTrackingInfo& );
        SwParaChangeTrackingInfo& operator=( const SwParaChangeTrackingInfo& );

        const SwTxtFrm& mrTxtFrm;

        SwWrongList* mpChangeTrackInsertionTextMarkupList;
        SwWrongList* mpChangeTrackDeletionTextMarkupList;
        SwWrongList* mpChangeTrackFormatChangeTextMarkupList;
};
#endif

/* vim:set shiftwidth=4 softtabstop=4 expandtab: */
